/*

This file is (C) Copyright 2002 Erik S. Johansen <einride@einride.org>, all 
rights reserved.

If you work for or represent an organisation, agency or corporation that is 
wholly or partially funded by a government -OR- you are in any way associated 
with the company Cyber Operations, the following licence applies.

You may not use this file or any derivatives of it for any purpose whatsoever,
including reading beyond this comment, redistribution or compiling, without 
explicit written permission from the copyright holder. 

If you do not work for or represent an organisation, agency or corporation 
that is wholly or partially funded by a government -AND- you are not in any 
way associated with the company Cyber Operations, the GNU General Public 
License, as described in the accompanying file GPL, applies.

*/
#include "debug.h"
#include "util.h"
#include "ui.h"

extern struct app_glob_struct glob;

void debug_dumpregisters(struct registers * r) {
  struct registers regs;
  if (!r) {
    if (trace_getregisters(glob.process, &regs)) {
      ui_showmessage(UI_LEVEL_ERROR, "Failed reading registers: Error %i", errno);
      return;
    }
    r=&regs;
  }
  ui_showmessage(UI_LEVEL_VDEBUG, "EAX=%08x EBX=%08x ECX=%08x EDX=%08x ESI=%08x EDI=%08x", 
	 r->eax, r->ebx, r->ecx, r->edx, r->esi, r->edi);
  ui_showmessage(UI_LEVEL_VDEBUG, "OAX=%08x ESP=%08x EBP=%08x EIP=%08x EFL=%08x", 
	 r->oeax, r->esp, r->ebp, r->eip, r->eflags);
}

void debug_dumpfdinfo(fdinfo * fd) {
  ui_showmessage(UI_LEVEL_DEBUG, "fd %i: Flags %x, Owner %x, Signal %x, Type %x", fd->fd, fd->flags, fd->owner, fd->iosig, fd->type);
  if (fd->type==FDTYPE_SOCKET) {
    ui_showmessage(UI_LEVEL_DEBUG, "fd %i: AF %i", fd->fd, * (int *) &(fd->sockname));
  }
}

